import { computed as x, watch as ne, ref as X, defineComponent as Pe, provide as ke, toRefs as Ie, useSlots as xe, onMounted as Te, openBlock as b, createElementBlock as C, Fragment as q, createElementVNode as j, normalizeClass as W, unref as e, renderSlot as R, normalizeProps as D, mergeProps as E, renderList as Q, toDisplayString as V, withModifiers as Fe, createCommentVNode as Y, createTextVNode as U } from "vue";
const $e = {
  items: {
    type: Array,
    default: () => [],
    required: !0,
    description: "Array of data objects, should be a flat array."
  },
  values: {
    type: Array,
    default: () => [],
    required: !0,
    description: "Array of value objects representing the metrics"
  },
  rows: {
    type: Array,
    default: () => [],
    description: "Array of row objects representing the dimensions on rows"
  },
  column: {
    type: Object,
    default: null,
    description: "Single column object representing the dimension on columns"
  },
  locale: {
    type: String,
    default: "en-US",
    description: "Locale setting for the table."
  },
  currentPage: {
    type: Number,
    default: 1,
    description: "Current page number."
  },
  noRowsCustom: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to use custom rows when no data is available."
  },
  emptyMessage: {
    type: String,
    default: "No Available Data",
    description: "Message to display when there is no available data."
  },
  filterOptions: {
    type: Array,
    default: null,
    description: "Array of filter options for the table."
  },
  hideFooter: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to hide the table footer."
  },
  hideHeader: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to hide the table header."
  },
  loading: {
    type: Boolean,
    default: !1,
    description: "Indicates whether the table is in a loading state."
  },
  rowsPerPage: {
    type: Number,
    default: 25,
    description: "Number of rows per page."
  },
  searchField: {
    type: [String, Array],
    default: "",
    description: "Field or fields to search within."
  },
  rowsItems: {
    type: Array,
    default: () => [25, 50, 100]
  },
  rowsOfPageSeparatorMessage: {
    type: String,
    default: "of"
  },
  searchValue: {
    type: String,
    default: "",
    description: "Value to search for within the specified field(s)."
  },
  showIndex: {
    type: Boolean,
    default: !1,
    description: "Indicates whether to display an index column."
  },
  showIndexSymbol: {
    type: String,
    default: "#",
    description: "Symbol used for the index column."
  },
  showIndexClass: {
    type: String,
    default: "",
    description: "Class used for the index column."
  },
  oddRowClass: {
    type: String,
    default: "odd-row",
    description: "CSS class applied to odd-numbered rows."
  },
  evenRowClass: {
    type: String,
    default: "even-row",
    description: "CSS class applied to even-numbered rows."
  },
  oddRowCellClass: {
    type: String,
    default: "odd-row-cell",
    description: "CSS class applied to cells in odd-numbered rows."
  },
  evenRowCellClass: {
    type: String,
    default: "even-row-cell",
    description: "CSS class applied to cells in even-numbered rows."
  },
  sortBy: {
    type: String,
    default: "",
    description: "Field or fields to sort by."
  },
  sortType: {
    type: String,
    default: "asc",
    description: "Sort type or types (ascending or descending)."
  },
  tableClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the table element."
  },
  innerTableClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the inner table element."
  },
  headerClassName: {
    type: String,
    default: "",
    description: "CSS class applied to the table header element."
  },
  mustSort: {
    type: Boolean,
    default: !1,
    description: "Indicates whether sorting is required."
  },
  tableNodeId: {
    type: String,
    default: "",
    description: "ID attribute for the table element."
  }
};
function z(s, o) {
  if (s.includes(".")) {
    const c = s.split("."), { length: p } = c;
    let a, v = 0;
    for (; v < p; ) {
      if (v === 0)
        a = o[c[0]];
      else if (a && typeof a == "object")
        a = a[c[v]];
      else {
        a = "";
        break;
      }
      v += 1;
    }
    return a ?? "";
  }
  return o[s];
}
function ge(s, o, c) {
  return s == null ? null : Array.isArray(s) ? s.join(", ") : (o.formatFunc ? s = o.formatFunc(s) : o.numberFormat && (s = new Intl.NumberFormat(c, o.numberFormat).format(s)), o.prefix && (s = o.prefix + s), o.suffix && (s = s + o.suffix), s);
}
function Re(s, o, c) {
  const p = z(s.value, o);
  return ge(p, s, c);
}
function Ae(s, o, c, p) {
  var v;
  let a;
  return s.columnValue ? a = (v = o.items.find((k) => k[c.value] === s.columnValue)) == null ? void 0 : v[s.value] : a = z(s.value, o.rows), ge(a, s, p);
}
function Ne(s, o, c, p, a, v, k, I, h) {
  const G = (g) => {
    if (typeof k.value == "string" && k.value !== "")
      return z(k.value, g);
    if (Array.isArray(k.value)) {
      let l = "";
      return k.value.forEach((m) => {
        l += z(m, g);
      }), l;
    }
    return Object.values(g).join(" ");
  }, M = x(() => {
    if (a.value) {
      const g = v.value.map((m) => m.value), l = p.value.reduce((m, S) => {
        const y = g.map((r) => S[r]).join("|"), u = m.find((r) => r.key === y);
        if (u)
          u.items.push(S);
        else {
          const r = Object.fromEntries(Object.entries(S).filter(([i]) => g.includes(i)));
          m.push({ key: y, rows: r, items: [S] });
        }
        return m;
      }, []);
      if (I.value !== "") {
        const m = new RegExp(I.value, "i");
        return l.filter((S) => m.test(S.key));
      }
      return l;
    }
    if (I.value !== "") {
      const g = new RegExp(I.value, "i");
      return p.value.filter((l) => g.test(G(l)));
    }
    return p.value;
  }), A = x(() => {
    let g = [...M.value];
    return a.value ? g : c.value ? (c.value.forEach((l) => {
      g = g.filter((m) => {
        const { field: S, comparison: y, criteria: u } = l;
        if (typeof y == "function")
          return y(z(S, m), u);
        const r = z(S, m);
        if (r === null)
          return !1;
        switch (y) {
          case "=":
            return r === u;
          case "!=":
            return r !== u;
          case ">":
            return r > u;
          case "<":
            return r < u;
          case "<=":
            return r <= u;
          case ">=":
            return r >= u;
          case "between":
            return r >= Math.min(...u) && r <= Math.max(...u);
          case "in":
            return Array.isArray(u) ? u.includes(r) : !0;
          default:
            return r === u;
        }
      });
    }), g) : M.value;
  });
  ne(
    A,
    (g) => {
      c.value && h("updateFilter", g);
    },
    { immediate: !0, deep: !0 }
  );
  const L = x(() => {
    if (o.value === null)
      return A.value;
    const g = [...A.value], { sortBy: l, sortDesc: m, columnValue: S } = o.value, { sortFunc: y } = s.value.find((r) => r.value === l);
    return g.sort((r, i) => {
      var $, F, K, N;
      let n, f;
      return a.value ? S ? (n = y ? y(($ = r.items.find((O) => O[a.value.value] === S)) == null ? void 0 : $[l]) : (F = r.items.find((O) => O[a.value.value] === S)) == null ? void 0 : F[l], f = y ? y((K = i.items.find((O) => O[a.value.value] === S)) == null ? void 0 : K[l]) : (N = i.items.find((O) => O[a.value.value] === S)) == null ? void 0 : N[l]) : (n = y ? y(r.rows[l]) : r.rows[l], f = y ? y(i.rows[l]) : i.rows[l]) : (n = y ? y(z(l, r)) : z(l, r), f = y ? y(z(l, i)) : z(l, i)), n === null && f !== null ? 1 : n !== null && f === null ? -1 : n === null && f === null ? 0 : n < f ? m ? 1 : -1 : n > f ? m ? -1 : 1 : 0;
    });
  }), T = x(() => L.value.length);
  return {
    totalItems: L,
    totalItemsLength: T
  };
}
function Ve(s, o, c, p, a, v, k, I, h, G, M) {
  const A = x(() => a.value ? [...new Set(s.value.map((u) => u[a.value.value]))] : []), T = X(((u, r) => u && u !== "" ? {
    sortBy: u,
    sortDesc: r === "desc"
  } : null)(h.value, G.value));
  let g = [];
  const l = x(() => {
    if (a.value) {
      const i = A.value.flatMap((n) => p.value.map(($) => ({
        ...$,
        columnValue: n
      })));
      g = [
        ...c.value.map((n) => ({ ...n, type: "tableRow" })),
        ...i.map((n) => ({ ...n, type: "tableValue" }))
      ];
    } else
      g = [
        ...c.value.map((i) => ({ ...i, type: "tableRow" })),
        ...p.value.map((i) => ({ ...i, type: "tableValue" }))
      ];
    const u = g.map((i) => {
      const n = Object.assign(i);
      return n.sortable && (n.sortType = "none"), T.value && n.value === T.value.sortBy && T.value.columnValue ? T.value.columnValue === n.columnValue ? n.sortType = T.value.sortDesc ? "desc" : "asc" : n.sortType = "none" : T.value && n.value === T.value.sortBy && (n.sortType = T.value.sortDesc ? "desc" : "asc"), n;
    });
    let r = [];
    return k.value ? r = [{
      text: o.value,
      value: "index",
      cssClass: I.value
    }, ...u] : r = u, r;
  }), m = x(() => {
    const u = [];
    if (a.value) {
      const r = l.value.reduce(
        (i, n) => {
          const f = n.columnValue;
          let $;
          n.columnValue ? a.value.formatFunc ? $ = a.value.formatFunc(n.columnValue) : $ = n.columnValue : $ = null;
          const F = i[i.length - 1];
          return F && F.text === $ && !F.isIndex && F.originalText === f ? F.count++ : i.push({
            type: "column",
            isIndex: n.value === "index",
            text: $,
            originalText: f,
            count: 1,
            cssClass: n.cssClass ?? ""
          }), i;
        },
        []
      );
      u.push(r);
    }
    if (l.value.findIndex((r) => r.parent) > -1) {
      const r = l.value.reduce(
        (i, n) => {
          var K;
          const f = ((K = n.parent) == null ? void 0 : K.text) || null, $ = n.columnValue, F = i[i.length - 1];
          return F && F.text === f && !F.isIndex && F.columnValue === $ ? F.count++ : i.push({
            type: "parent",
            isIndex: n.value === "index",
            columnValue: $,
            text: f,
            count: 1,
            cssClass: n.cssClass ?? ""
          }), i;
        },
        []
      );
      u.push(r);
    }
    return u;
  }), S = x(() => l.value.map((u) => u.value));
  return {
    columnDomain: A,
    clientSortOptions: T,
    headerColumns: S,
    headersForRenderParents: m,
    headersForRender: l,
    updateSortField: (u, r, i = !1, n = void 0) => {
      let f = null;
      i ? f = r === "none" ? null : r : r === "none" ? f = "asc" : r === "asc" ? f = "desc" : f = v.value ? "asc" : null, f === null ? T.value = null : T.value = {
        sortBy: u,
        sortDesc: f === "desc",
        columnValue: n
      }, M("updateSort", {
        columnValue: n,
        sortType: f,
        sortBy: u
      });
    }
  };
}
function Me(s, o) {
  const c = x(() => s.value.findIndex((v) => v === o.value) === -1 ? [o.value, ...s.value] : s.value), p = X(o.value);
  return {
    rowsItemsComputed: c,
    rowsPerPageRef: p,
    updateRowsPerPage: (v) => {
      p.value = v;
    }
  };
}
function Oe(s, o, c, p) {
  const a = X(s.value), v = x(() => Math.ceil(c.value / p.value)), k = x(
    () => v.value === 0 || a.value === v.value
  ), I = x(() => a.value === 1);
  return {
    currentPaginationNumber: a,
    maxPaginationNumber: v,
    isLastPage: k,
    isFirstPage: I,
    nextPage: () => {
      c.value !== 0 && (k.value || o.value || (a.value += 1));
    },
    prevPage: () => {
      c.value !== 0 && (I.value || o.value || (a.value -= 1));
    },
    updatePage: (L) => {
      o.value || (a.value = L);
    },
    updateCurrentPaginationNumber: (L) => {
      a.value = L;
    }
  };
}
function Be(s, o, c, p, a) {
  const v = x(() => (s.value - 1) * o.value + 1), k = x(() => Math.min(p.value.length, s.value * o.value)), I = x(() => o.value === -1 ? p.value : p.value.slice(v.value - 1, k.value)), h = x(() => c.value ? a.value ? I.value.map((M, A) => (M.rows = { index: v.value + A, ...M.rows }, M)) : I.value.map((M, A) => ({ index: v.value + A, ...M })) : I.value), G = x(() => h.value);
  return {
    currentPageFirstIndex: v,
    currentPageLastIndex: k,
    pageItems: G
  };
}
const je = [
  { name: "scroll", description: "Triggered when scrolling" },
  { name: "clickRow", description: "Triggered when a row is clicked" },
  { name: "clickCell", description: "Triggered when a cell is clicked" },
  { name: "updateSort", description: "Triggered when sorting is updated" },
  { name: "updateFilter", description: "Triggered when filtering is updated" },
  { name: "updatePageItems", description: "Triggered when page items are updated" },
  { name: "updateTotalItems", description: "Triggered when total items are updated" },
  { name: "mouseover", description: "Triggered when mouse is over" },
  { name: "mouseleave", description: "Triggered when mouse leaves" }
], De = je.map((s) => s.name), Ee = ["id"], Le = ["colspan"], _e = { class: "header" }, ze = {
  key: 2,
  class: "header-text"
}, Ge = ["onClick"], He = { class: "header" }, qe = {
  key: 3,
  class: "header-text"
}, We = ["id"], Ue = ["role", "onClick", "onMouseover", "onMouseleave"], Ke = { id: "errors" }, Je = { style: { color: "red" } }, Qe = { key: 5 }, Xe = /* @__PURE__ */ Pe({
  __name: "PivotDataTable",
  props: $e,
  emits: De,
  setup(s, { expose: o, emit: c }) {
    const p = X([]), a = X();
    ke("dataTable", a);
    const v = s, {
      values: k,
      rows: I,
      column: h,
      locale: G,
      tableNodeId: M,
      currentPage: A,
      filterOptions: L,
      emptyMessage: T,
      noRowsCustom: g,
      items: l,
      loading: m,
      mustSort: S,
      rowsItems: y,
      rowsPerPage: u,
      searchField: r,
      searchValue: i,
      showIndex: n,
      sortBy: f,
      sortType: $,
      showIndexSymbol: F,
      showIndexClass: K
    } = Ie(v), N = xe(), O = c, { clientSortOptions: me, headersForRenderParents: ye, headersForRender: _, updateSortField: Z } = Ve(
      l,
      F,
      I,
      k,
      h,
      S,
      n,
      K,
      f,
      $,
      O
    ), { totalItems: de, totalItemsLength: ee } = Ne(
      _,
      me,
      L,
      l,
      h,
      I,
      r,
      i,
      O
    ), { rowsItemsComputed: we, rowsPerPageRef: te, updateRowsPerPage: he } = Me(y, u), { currentPaginationNumber: oe, maxPaginationNumber: le, isLastPage: ce, isFirstPage: pe, nextPage: se, prevPage: re, updatePage: ae } = Oe(A, m, ee, te), { currentPageFirstIndex: ue, currentPageLastIndex: ie, pageItems: ve } = Be(
      oe,
      te,
      n,
      de,
      h
    ), be = (d, B, t, P) => {
      O("clickCell", d, B, t, P);
    };
    ne(te, () => {
      ae(1);
    }), ne([i, L], () => {
      ae(1);
    }), ne(
      [l, h],
      () => {
        Ce();
      },
      { immediate: !0 }
    );
    const fe = X(!1);
    function Ce() {
      p.value = [], h.value && Array.isArray(h.value) ? p.value.push({
        type: "propError",
        text: "column is of type Array"
      }) : h.value && Se() && p.value.push({
        type: "dataShapeError",
        text: "duplicate item Objects (by rows * columns) found in items"
      });
    }
    Te(() => {
      a.value.addEventListener("scroll", () => {
        fe.value = a.value.scrollLeft > 0;
      });
    }), o({
      currentPageFirstIndex: ue,
      currentPageLastIndex: ie,
      clientItemsLength: ee,
      totalItems: de,
      maxPaginationNumber: le,
      currentPaginationNumber: oe,
      isLastPage: ce,
      isFirstPage: pe,
      nextPage: se,
      prevPage: re,
      updatePage: ae,
      updateSortField: Z,
      rowsPerPageOptions: we,
      rowsPerPageActiveOption: te,
      updateRowsPerPageActiveOption: he
    });
    function Se() {
      const d = [...I.value.map((t) => t.value), h.value.value], B = /* @__PURE__ */ new Set();
      for (let t = 0; t < l.value.length; t++) {
        const P = d.map((w) => l.value[t][w]).join("|");
        if (B.has(P))
          return !0;
        B.add(P);
      }
      return !1;
    }
    return (d, B) => (b(), C(q, null, [
      j("div", {
        ref_key: "dataTable",
        ref: a,
        class: W(["vue3-pivot-data-table", [d.tableClassName]]),
        onScroll: B[0] || (B[0] = (t) => d.$emit("scroll", t))
      }, [
        j("table", {
          id: e(M),
          class: W({
            [d.innerTableClassName]: !0,
            "show-shadow": fe.value
          })
        }, [
          e(N)["customize-headers"] ? R(d.$slots, "customize-headers", D(E({ key: 0 }, { headersForRender: e(_), updateSortField: e(Z) })), void 0, !0) : e(_).length && !d.hideHeader ? (b(), C("thead", {
            key: 1,
            class: W([d.headerClassName])
          }, [
            (b(!0), C(q, null, Q(e(ye), (t, P) => (b(), C("tr", {
              key: "headerRowGroup" + P
            }, [
              (b(!0), C(q, null, Q(t, (w, H) => (b(), C("th", {
                key: "columnHeader" + H,
                colspan: w.count,
                class: W([
                  {
                    shadow: H === 0,
                    [w.cssClass ?? ""]: !0,
                    [w.type ?? ""]: !0
                  }
                ])
              }, [
                j("span", _e, [
                  e(N)[`header-${w.type}-${w.text}`] ? R(d.$slots, `header-${w.type}-${w.text}`, D(E({ key: 0 }, w)), void 0, !0) : e(N).header ? R(d.$slots, "header", D(E({ key: 1 }, w)), void 0, !0) : (b(), C("span", ze, V(w.text), 1))
                ])
              ], 10, Le))), 128))
            ]))), 128)),
            j("tr", null, [
              (b(!0), C(q, null, Q(e(_), (t, P) => (b(), C("th", {
                key: P,
                role: "button",
                tabindex: 0,
                class: W([
                  {
                    sortable: t.sortable,
                    none: t.sortable && t.sortType === "none",
                    desc: t.sortable && t.sortType === "desc",
                    asc: t.sortable && t.sortType === "asc",
                    shadow: P === 0,
                    [t.cssClass ?? ""]: !0,
                    [t.type ?? ""]: !0
                  }
                ]),
                onClick: Fe((w) => t.sortable && t.sortType ? e(Z)(t.value, t.sortType, !1, t.columnValue) : null, ["stop"])
              }, [
                j("span", He, [
                  e(N)[`header-${t.value}`] ? R(d.$slots, `header-${t.value}`, D(E({ key: 0 }, t)), void 0, !0) : e(N)[`header-${t.value.toLowerCase()}`] ? R(d.$slots, `header-${t.value.toLowerCase()}`, D(E({ key: 1 }, t)), void 0, !0) : e(N).header ? R(d.$slots, "header", D(E({ key: 2 }, t)), void 0, !0) : (b(), C("span", qe, V(t.text), 1)),
                  t.sortable && e(N)["sort-icon"] ? R(d.$slots, "sort-icon", D(E({ key: 4 }, t)), void 0, !0) : t.sortable ? (b(), C("i", {
                    key: t.sortType ? t.sortType : "none",
                    class: W(["sortType-icon", { desc: t.sortType === "desc" }])
                  }, null, 2)) : Y("", !0)
                ])
              ], 10, Ge))), 128))
            ])
          ], 2)) : Y("", !0),
          j("tbody", null, [
            (b(!0), C(q, null, Q(e(ve), (t, P) => (b(), C("tr", {
              id: `row-${P}`,
              key: P,
              class: W([{ [d.oddRowClass]: (P + 1) % 2 === 0 }, { [d.evenRowClass]: P % 2 === 0 }]),
              role: "button",
              tabindex: 0
            }, [
              (b(!0), C(q, null, Q(e(_), (w, H) => (b(), C("td", {
                key: H,
                role: e(_)[H].clickable || e(_)[H].hoverable ? "button" : "",
                tabindex: "0",
                class: W([
                  {
                    [d.oddRowCellClass]: (P + 1) % 2 === 0,
                    [d.evenRowCellClass]: P % 2 === 0,
                    shadow: H === 0,
                    [w.cssClass ?? ""]: !0,
                    [w.type ?? ""]: !0
                  }
                ]),
                onClick: (J) => be(t, e(_)[H], P, J),
                onMouseover: (J) => O("mouseover", t, e(_)[H], J),
                onMouseleave: (J) => O("mouseleave", t, J)
              }, [
                e(N)[`item-${w.value}`] ? R(d.$slots, `item-${w.value}`, D(E({ key: 0 }, e(h) ? t.items.find((J) => J[e(h).value] === w.columnValue) : t)), void 0, !0) : e(N).item ? R(d.$slots, "item", D(E({ key: 1 }, { column: e(h), item: t })), void 0, !0) : e(h) ? (b(), C(q, { key: 2 }, [
                  U(V(e(Ae)(w, t, e(h), e(G))), 1)
                ], 64)) : (b(), C(q, { key: 3 }, [
                  U(V(e(Re)(w, t, e(G))), 1)
                ], 64))
              ], 42, Ue))), 128))
            ], 10, We))), 128))
          ]),
          e(N)["customize-footers"] ? R(d.$slots, "customize-footers", D(E({ key: 2 }, {
            headersForRender: e(_),
            updateSortField: e(Z)
          })), void 0, !0) : Y("", !0)
        ], 10, Ee)
      ], 34),
      p.value.length ? R(d.$slots, "errors", { key: 0 }, () => [
        j("div", Ke, [
          j("ul", null, [
            (b(!0), C(q, null, Q(p.value, (t, P) => (b(), C("li", {
              key: "error" + P
            }, [
              j("span", Je, V(t.type) + ":", 1),
              U(" " + V(t.text), 1)
            ]))), 128))
          ])
        ])
      ], !0) : !e(l).length && !e(m) && e(g) ? R(d.$slots, "no-rows-custom", { key: 1 }, () => [
        U(" Slot: no-rows-custom ")
      ], !0) : !e(l).length && !e(m) ? R(d.$slots, "no-rows", { key: 2 }, () => [
        U(V(e(T)), 1)
      ], !0) : !e(ve).length && !e(m) ? R(d.$slots, "empty-message", { key: 3 }, () => [
        U(V(e(T)), 1)
      ], !0) : Y("", !0),
      e(N).footer ? R(d.$slots, "footer", D(E({ key: 4 }, {
        currentPageFirstIndex: e(ue),
        currentPageLastIndex: e(ie),
        rowsOfPageSeparatorMessage: d.rowsOfPageSeparatorMessage,
        totalItemsLength: e(ee),
        isFirstPage: e(pe),
        isLastPage: e(ce),
        currentPaginationNumber: e(oe),
        maxPaginationNumber: e(le),
        nextPage: e(se),
        prevPage: e(re),
        updatePage: e(ae)
      })), void 0, !0) : d.hideFooter ? Y("", !0) : (b(), C("div", Qe, [
        U(V(`${e(ue)}–${e(ie)}`) + " " + V(d.rowsOfPageSeparatorMessage) + " " + V(e(ee)) + " ", 1),
        j("button", {
          onClick: B[1] || (B[1] = //@ts-ignore
          (...t) => e(re) && e(re)(...t))
        }, V("<")),
        U(" " + V(e(A)) + " of " + V(e(le)) + " ", 1),
        j("button", {
          onClick: B[2] || (B[2] = //@ts-ignore
          (...t) => e(se) && e(se)(...t))
        }, ">")
      ]))
    ], 64));
  }
});
const Ye = (s, o) => {
  const c = s.__vccOpts || s;
  for (const [p, a] of o)
    c[p] = a;
  return c;
}, tt = /* @__PURE__ */ Ye(Xe, [["__scopeId", "data-v-d1c1fc50"]]);
export {
  tt as default
};
